# Installation

This is a [Node.js](https://nodejs.org/en/) module available through the
[npm registry](https://www.npmjs.com/).

Before installing, [download and install Node.js](https://nodejs.org/en/download/).

If this is a brand new project, make sure to create a `package.json` first with
the [`npm init` command](https://docs.npmjs.com/creating-a-package-json-file).

Installation is done using the
[`npm install` command](https://docs.npmjs.com/getting-started/installing-npm-packages-locally):

```bash
$ npm install secret-santa-draw
```

## How to use

Example of `shuffle()`:

```tsx
import {shuffle} from "secret-santa-draw";

const array = ["Kevin", "Sara", "John", "Jane", "Bob"];

const shuffledIndices = shuffle(array.length - 1);
const shuffledArray: string[] = [];

for (let i = 0; i < array.length; i++) {
    const shuffledIndex = shuffledIndices[i];
    shuffledArray[i] = array[shuffledIndex];
}
```

Example of `draw()`:

```tsx
import {draw} from "secret-santa-draw";

const array = ["Kevin", "Sara", "John", "Jane", "Bob"];
const shuffledArray = draw(array);
```